;__________________________________________________________________________;
;_________________________________INCLUDES_________________________________;
;__________________________________________________________________________;

.plugin lite86
#include "ti86asm.inc"
#include "ti86und.inc"
#include "ti86abs.inc"
#include "asm86.h"

;__________________________________________________________________________;
;_________________________________VARIABLES________________________________;
;__________________________________________________________________________;

_user_int_ram	= $D2FD
GrayDraw1		= $FC00
GrayDraw2		= $F300
Flag_Number		=	_textShadow				; 1
TileMap			=	_textShadow+1			; 128
Unknow_NB		=	_textShadow+129			; 2
StringPlace		=	_textShadow+131			; 3
Time			=	_textShadow+134			; 2
Time_Saved		=	_textShadow+136			; 2
Counter_Saved	=	_textShadow+138			; 2
Opened_Flag		=	_textShadow+140			; 1
Level			=	_textShadow+141			; 1
Empty_Box		=	_textShadow+142			; 1
capflag			=	_textShadow+143			; 1

;__________________________________________________________________________;
;____________________________LE PROGRAMME__________________________________;
;__________________________________________________________________________;

.org _asm_exec_ram				; O commence le programme.

	nop
	jp ProgStart
	.dw 1
	.dw ShellTitle
	.dw ShellIcon

ShellTitle:
	.db "Demineur v2.0 by Etienne Mansot",0

ShellIcon:
	.db 8,1
	.db %00000110
	.db %00001000
	.db %00111100
	.db %01110010
	.db %01111010
	.db %01111110
	.db %01111110
	.db %00111100

Name:
	.db 8,"Demineur"

HiScore_Data:
	.db " ----------------",0,$E7,$03,00,00
	.db " ----------------",0,$E7,$03,00,00
	.db " ----------------",0,$E7,$03,00,00
	.db " ----------------",0,$E7,$03,00,00
	.db " ----------------",0,$E7,$03,00,00

ProgStart:
	ld a,r						; Je rcupre un nombre inconnu.
	ld (Unknow_NB),a			; Je le garde en mmoire.
	call _runindicoff			; J'arrte l'indicateur de marche.
	call _flushallmenus			; Je ferme les menu ouvert

OpenGray:						; Fait pour mettre en place le GrayScale.
	res 2,(iy+$23)				; J'arrte les interrupts (sinon CRASH).
	ld hl,IntRoutine			; hl = dbut du GrayScale routine.
	ld de,_user_int_ram+1		; de = mem des interrupts.
	push de						; Je sauve le position.
	ld bc,InterruptMemEnd-IntRoutine;bc = nb de bytes  recopier.
	ldir						; je fait la copie.
	ld de,$28					; ce que je dois ajouter a hl pour le Check.
	pop hl						; Je restore le mem des interrupts.
	ld a,(hl)					; Je prends le premier Byte.
	dec hl						; Je met positionne sur le Checksum.
	push hl						; Je sauvez la position.
	ld b,5						; nb de byte pour le Checksun.
OpenGray_Checksum:				;
	add hl,de					; Je vais a postion+$28
	add a,(hl)					; et j'ajoute le byte  a.
	djnz OpenGray_Checksum		; Je le fait 5 fois.
	pop hl						; Je restore la position du checksun.
	ld (hl),a					; Je met le check en place.
	xor a						; a=0 (plus rapide et plus petit que ld a,0)
	ld (IntCounter),a			; conteur pour les bonnes pages  afficher.
	ld (UserCounter),a			; J'utilise celui-ci pour le temps.
	ld de,IntData 				;\je mets en place la valeur
	ld hl,SourceIntData			; }des ecrans qui doivent tre affich
	ld bc,2						; }il sont au nombre de 2
	ldir						;/
	set 2,(iy+$23)				; Je remets en marche les interrupts

;__________________________________________________________________________;
;____________________________MENU PRICIPALE________________________________;
;__________________________________________________________________________;

MainMenu:
	call ClearPage
	call _homeup
	ld hl,Title
	set textInverse,(iy+textflags)
	call _puts
	res textInverse,(iy+textflags)
	ld b,$05
	ld de,$0501
Disp_Txt:
	inc e
	ld	(_curRow),de
	call _puts
	djnz Disp_Txt
	ld bc,1024
	ld hl,$FC00
	ld de,$F300
	ldir
	ld c,5
	ld b,3
	ld hl,HiScore_Data +44+18
	jr DoMenuBar
DoMenuFirst:
	ld b,1
	ld hl,HiScore_Data +18
DoMenuBar:
	call DoMenuInvBar
DoMenuL:
	push hl
	call $4068
	pop hl
	cp K_UP
	jr z,DoMenuUp
	cp K_DOWN
	jr z,DoMenuDown
	cp K_PLUS
	call z,inc_contrast
	cp K_MINUS
	call z,dec_contrast
	cp K_SECOND
	jr z,DoMenuSelect
	cp K_EXIT
	jp z,Exit
	cp K_ENTER
	jr nz,DoMenuL
DoMenuSelect:
	ld hl,Mine_On_Level - 1
	ld a,b
	ld (Level),a
	ld c,b
	ld b,0
	add hl,bc
	ld b,(hl)
	ld a,128				; 128 = nb de boite.
	sub b					; cela me donne le nb de boite vide.
	ld (Empty_Box),a
	jp Init_Game

DoMenuUp:
	call DoMenuInvBar
	dec b
	ld de,0022
	sbc hl,de
	ld a,b
	or a
	jr nz,DoMenuBar
	ld b,c
	ld hl,HiScore_Data+88+18
	jr DoMenuBar
DoMenuDown:
	call DoMenuInvBar
	ld a,c
	cp b
	jr z,DoMenuFirst
	inc b
	ld de,0022
	add hl,de
	jr DoMenuBar

DoMenuInvBar:
	push hl
	push bc
	push hl
	ld hl,$FFFF-80+1
	ld de,$FFFF-80+2
	ld (hl),0
	ld bc,78
	ldir
	ld hl,$F6FF-80+1
	ld de,$F6FF-80+2
	ld (hl),0
	ld bc,78
	ldir
	ld hl,Who's_The_Best
	call Disp_Text
	pop hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	push hl
	ex de,hl
	ld de,$3A1D
	ld (_penCol),de
	call Show_a_NB
	pop hl
	ld de,0019
	sbc hl,de
	ld de,$3A34
	ld (_penCol),de
	call _vputs
	pop bc
	push bc
	ld h,b
	ld l,128
	call _HtimesL
	ld de,$f380
	add hl,de
	ex de,hl
	call DoMenuInv
	pop bc
	pop hl
	ret
DoMenuInv:
	ld b,8*16
	push de
	push de
DoMenuIL:
	ld a,(de)
	cpl
	ld (de),a
	inc de
	djnz DoMenuIL
	pop hl
	ld de,$900
	add hl,de
	pop de
	ld b,8*16
DoMenuIL2:
	ld a,(de)
	or (hl)
	ld (de),a
	inc de
	inc hl
	djnz DoMenuIL2 
	ret

;__________________________________________________________________________;
;_________________________________GAME_____________________________________;
;__________________________________________________________________________;

Init_Game:
	push bc					; je sauvegarde bc (bc = nb de mines a mettre).
	ld hl,_textShadow		;
	ld de,_textShadow+1		;
	ld (hl),0				;
	ld bc,140				;
	ldir					;
	pop bc					;
	ld hl,TileMap+1			;
	push hl					;
Init_Loop:					;
	ld (hl),$09				;
	inc hl					;
	djnz Init_Loop			;
	pop hl					;
	ld a,(UserCounter)		;
	add a,17				;
	add a,h					;
	add a,l					;
	ld (Unknow_NB+1),a		;
	ld b,$7F				; $7F=127.
Mix_TileMap:				;
	push bc					; Sauve loop conteur.
	push hl					; Sauve une position dans TileMap.
	ld bc,(Unknow_NB)		; Je rcupre une valeur inconnu.
	ld h,c					; h=c=0?.
	ld l,b					; l=b=r (nb du dbut)=>hl = nb du dbut?.
	srl h					;\h/2 bit 0 dans Carry, bit 7 = 0.
	rr l					;/l/2 Carry dans bit 7 =>hl/2.
	srl h					;\h/2 bit 0 dans Carry, bit 7 = 0.
	rr l					;/l/2 Carry dans bit 7 =>hl/4.
	ccf						; Carry = 0.
	sbc hl,bc				; hl = -3/4 du nb du dbut.
	sla c					;\c*2 bit 7 dans Carry, bit 0 = 0.
	rl b					;/b*2 Carry dans bit 0 =>bc*2.
	ccf						; Carry = 0.
	sbc hl,bc				; hl = -11/4 du nb du dbut.
	sla c					;\c*4 bit 7 dans Carry, bit 0 = 0.
	rl b					;/b*4 Carry dans bit 0 =>bc*4.
	sla c					;\c*8 bit 7 dans Carry, bit 0 = 0.
	rl b					;/b*8 Carry dans bit 0 =>bc*8.
	ccf						; Carry = 0.
	sbc hl,bc				; hl = -43/4 du nb du dbut.
	ld bc,$0011				; $0011=17.
	add hl,bc				; hl = -43/4 du nb du dbut + 11.
	ld bc,$007F				; $007F=127.
Good_H:						;
	xor a					; a=0.
	cp h					; Est-ce que h=0.
	jr z,Good_L				; Si oui,je saute plus bas.
	ccf						; Si non,
	sbc hl,bc				; Je supprime bc=127  hl
	jr Good_H				; Et je recommence.
Good_L:						;
	ld a,$7E				; a=126
	cp l					; Est-ce que l<126.
	jr nc,Good_HL			; Si oui,je saute plus bas.
	ccf						; Si non,
	sbc hl,bc				; Je supprime bc=127  hl
	jr Good_L				; Et je recommence.
Good_HL:					;
	ld (Unknow_NB),hl 		; Je sauvegarde hl qui maintemant est un nb<126.
	inc hl					; Je l'augmente.
	ld de,TileMap			;\Je lui ajoute
	add hl,de				;/La position de la TileMap.
	pop de					; Rcupre la position dans TileMap.
	ld a,(de)				; Je rcup le Tile dans la TileMap.
	ld b,(hl)				; Je rcupre celui de sa nouvelle position.
	ex de,hl				; J'change les deux position.
	ld (de),a				;\
	ld (hl),b				;/J'inverse les Tiles.
	inc hl					; J'augmente hl pou tre sur la prochaine mines.
	pop bc					; Restaure loop conteur.
	djnz Mix_TileMap		; Je retourne faire le mlange.
	ld b,$80				; Il y a 128 boites  faire.
	ld hl,$0000				; Position du cursor  (0,0).
Box_Number_Loop:			;
	call Get_The_Tile		; Je recupre le Tile qui est a la position hl.
	cp $09					; Est_ce que c'est $09=BombSprite.
	jr nz,No_Inc_Box_Nb		; Si ce ne l'est pas je passe la serie de test.
	ex de,hl				; sauve la position du cursor.
	ld hl,Flag_Number		; Pour savoir le nb de Drapeau que le joueur a.
	inc (hl)				; J'augmente le nb si il y a une mine.
	ex de,hl				; Restore la position du cursor.
	dec l					; Je vais sur la boite au dessus.
	call Inc_Box_Number		; augmente le nb de la boite si possible.
	inc h					; Je vais sur la boite au dessus a droite.
	call Inc_Box_Number		; augmente le nb de la boite si possible.
	inc l					; Je vais sur la boite a droite.
	call Inc_Box_Number		; augmente le nb de la boite si possible.
	inc l					; Je vais sur la boite au dessous a droite.
	call Inc_Box_Number		; augmente le nb de la boite si possible.
	dec h					; Je vais sur la boite au dessous.
	call Inc_Box_Number		; augmente le nb de la boite si possible.
	dec h					; Je vais sur la boite au dessous a gauche.
	call Inc_Box_Number		; augmente le nb de la boite si possible.
	dec l					; Je vais sur la boite a gauche.
	call Inc_Box_Number		; augmente le nb de la boite si possible.
	dec l					; Je vais sur la boite au dessus a gauche.
	call Inc_Box_Number		; augmente le nb de la boite si possible.
	inc h					; Je vais sur la boite au dessus.
	inc l					; Je vais sur la boite de dpart.
No_Inc_Box_Nb:				; 
	call Move_HL_Cursor		; Je dplace le cursor.
	djnz Box_Number_Loop	; Je test la mine d'aprs.
	ld hl,TileMap			; hl est au debut de TileMap.
	ld b,$80				; B = 128 car il y a 128 boites.
Close_Box:					;
	set 7,(hl)				; Bit 7 set correspond a une boite ferm.
	inc hl					; hl est sur la boite d'aprs.
	djnz Close_Box			; Fermer toutes les boites.
	call Draw_TileMap		;

;__________________________________________________________________________;
;______________________________GAMELOOP____________________________________;
;__________________________________________________________________________;

	ld hl,$0000				; Curseur Position (0,0) = en haut a gauche
Disp_Cursor:
	ld a,$0D
	call Draw_A_Tile
	ld a,(Flag_Number)
	or a
	jr nz,GameLoop
	ld a,(Empty_Box)
	or a
	jp z,Put_Result
GameLoop:
	push hl					; Save la position du cursor.
	ld a,(Opened_Flag)
	or a
	jr nz,Time_has_Started
	ld hl,$0000				; Curseur Position (0,0) = en haut a gauche
	xor a
	ld (UserCounter),a
	ld (Time),hl
Time_has_Started:
	call _getky				; Quelle touche est press?
	pop hl					; restore la position du cursor.
	or a
	jr z,GameLoop			; Si non, je remonte faire clignoter car no move
	cp K_SECOND				; Est-ce que c'est SECOND qui est press?
	jp z,Open_Box			; Si oui, je saute ouvrir la boite.
	cp K_ALPHA				; Est-ce que c'est F1 qui est press?
	jp z,Put_A_Flag			; Si oui, je saute mettre un drapeau.
	cp K_EXIT				; Est-ce que c'est EXIT qui est press?
	jp z,MainMenu			; Si oui, je montre quel etait le rsultat.
	cp K_PLUS
	call z,inc_contrast
	cp K_MINUS
	call z,dec_contrast
	cp K_MORE
	jp z,Pause
	cp $05
	jr nc,GameLoop			; Si non, je remonte faire clignoter car no move
Movement:
	ld a,$0D
	call Draw_A_Tile
	ld a,%11111110
	out (1),a
	in a,(1)
	cp $FF
	jr z,GameLoop			; Si non, je remonte faire clignoter car no move
	ld bc,$2800
Key_Timer_Loop:
	dec bc
	ld a,c
	or a
	jr nz,Key_Timer_Loop
	ld a,b
	or a
	jr nz,Key_Timer_Loop
Not_Timer_Key_Loop:
	ld a,%11111110
	out (1),a
	in a,(1)
	push af					; Sauvegarde du code de la touche
	call Draw_HL_Tile		; Rdessine la boite pour effacer le cursor.
	pop af					; Restitue le code de la touche
	rrca					; Est-ce le bas?
	jr nc,Go_Down
	rrca					; Est-ce le gauche?
	jr nc,Go_Left			; Si oui, je bouge a gauche.
	rrca					; Est-ce le droit?
	jr nc,Go_Right			; Si oui, je bouge a droite.
	rrca					; Est-ce le haut?
	jr nc,Go_Up				; Si oui, je bouge en haut sinon en bas.
	jp Disp_Cursor

Go_Down:					;
	ld a,$07				; $07 pour l = tout en bas.
	cp l					; Suis-je tout en bas?
	jr z,Movement			; Si oui, je ne bouge pas.
	inc l					; sinon je descend.
	jr Movement				; et je recommence avec les touches.
Go_Left:					;
	xor a					; $00 pour h = tout a gauche.
	cp h					; Suis-je tout 	 gauche?
	jr z,Movement			; Si oui, je ne bouge pas.
	dec h					; sinon je bouge a gauche.
	jr Movement				; et je recommence avec les touches.
Go_Right:					;
	ld a,$0F				; $0F pour l = tout en droite.
	cp h					; Suis-je tout a droite?
	jr z,Movement			; Si oui, je ne bouge pas.
	inc h					; Sinon je bouge a droite.
	jr Movement				; et je recommence avec les touches.
Go_Up:						;
	xor a					; $00 pour l = tout en haut.
	cp l					; Suis-je tout en haut?
	jr z,Movement			; Si oui, je ne bouge pas.
	dec l					; sinon je monte.
	jr Movement				; et je recommence avec les touches.

Put_A_Flag:					;
	call Get_The_Tile		; Rcupre le Tile qui est dans la TileMap.
	bit 7,a					; Est-ce que bit 7 = 0.
	jp z,GameLoop			; Si bit 7 = 0 la boite est ouverte.
	bit 6,a					; Est-que bit 6 = 1?
	jr nz,Flag_to_Question	; Si oui, il y a un drapeau, il faut une ? .
	bit 5,a					; Est-que bit 5 = 0?
	jr z,One_More_Flag		; Si oui, il n'y a pas de drapeau.
	res 5,a					; Il y a un drapeau->je l'enlve.
	jr Put_Flag_Change		; Je vais faire les changements.
One_More_Flag:				;
	ld b,a					; Sauve le Tile.
	ld a,(Flag_Number)		; Recupre le nombre de drapeau restant.
	or a					; Est-ce qu'il est de 0.
	jp z,Disp_Cursor		; Non, je peut en mettre un.
	dec a					; Je diminue le nomdre de drapeau restant.
	ld (Flag_Number),a		; Je remet le nb de drapeau restant en mem.
	ld a,b					; Restaure le Tile.
	set 6,a					; Je met un drapeau.
	jr Put_Flag_Change		; Je saute faire le changement.
Flag_to_Question:				;
	set 5,a					; Je met une question.
	ex de,hl				; Sauve la position du cursor.
	ld hl,Flag_Number		; hl pointe sur la mem du nb de drapeau restant.
	inc (hl)				; J'augmente le nomdre de drapeau restant.
	ex de,hl				; Restaure la position du cursor.
	res 6,a					; J'enlve le drapeau
Put_Flag_Change:			;
	call Change_The_Tile	; Je met le nouveau Tile en mmoire.
	call Draw_A_Tile		; Je Change le Sprite  l'cran.
	jp Disp_Cursor			; remonter prendre les touches.

Open_Box:
	ld a,1
	ld (Opened_Flag),a
	call Test_Box			; Serie de test pour les boites.
	jr c,Put_Result			; Si Carry = 1,le joueur a ouvert une mine.
	call Draw_TileMap		; Redessine la TileMap a l'ecran,elle a changer.
	jp Disp_Cursor			; Je remonte

Put_Result:
	push af
	ld hl,(Time)
	ld (Time_Saved),hl
	jr nc,No_Boum
	xor a
	out (2),a
No_Boum:
	call Draw_HL_Tile
	ld hl,$0000				; Position dans la TileMap.
	ld b,$80				; $80=128=nb de Tile.
Put_Result_Loop:			;
	call Get_The_Tile       ; Tile a la position hl.
	push af					; Sauve le Tile.
	and $1F					; Supprime Bit 7 et 6 pour ouvrir les boites.
	cp $09					; Est-ce que c'etait une Mine?
	jr nz,Not_A_Bomb		; Non, alors je saute voire si mauvais drapeau?
	pop af					; Restaure le Tile.
	bit 6,a					; Est-ce que le joueur avait mis un drapeau?
	jr z,Bomb_Not_Find		; Oui, alors il l'avait trouv.
	ld a,$0E
Bomb_Not_Find:
	and $1F
	jr Result_Done			; Le resultat est bon.
Not_A_Bomb:					;
	pop af
	bit 6,a
	jr z,Result_Done
	ld a,$0C
Result_Done:				;
	call Draw_A_Tile
	call Move_HL_Cursor		; Dplace le test cursor.
	djnz Put_Result_Loop	; Recommence pour la boite d'aprs.
	pop af
	jr nc,Success
	ld a,($C008)
	out (2),a
	call Wait
	ld hl,Title_of_Loser
	ld de,$0403
	call Disp_Window
	ld hl,Game_Over
	call Disp_Text
Result_Wait:				;
	call _getky				; Quelle touche est press?
	or a					; Est-ce EXIT
	jr z,Result_Wait		; Non, alors je reprend la touche.
	jp MainMenu

Success:
	call Wait
	ld hl,Congratu_Window
	ld de,$0201
	call Disp_Window
	ld hl,Congratulation
	call Disp_Text
	ld hl,$F457
	ld d,%00000100
	ld bc,%0000101000001110
	call Draw_Line_V
	ld hl,(Time_Saved)
	ld de,$182C
	call Show_a_NB
	ld a,(Level)
	ld b,a
	ld hl,HiScore_Data-2
	ld de,0022
Disp_Successed_Game:
	add hl,de
	djnz Disp_Successed_Game
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc de
	ld (hl),d
	dec hl
	ld (hl),e
	dec hl
	ex de,hl
	push de
	ld de,$185E
	call Show_a_NB
	pop hl
	ld bc,(Time_Saved)		;de
	ld a,b
	cp (hl)				; d=a;a
	dec hl
	jr z,No_New_Hiscore
	jr nc,Result_Wait
No_New_Hiscore:
	ld a,c
	cp (hl)
	jr nc,Result_Wait
	ex de,hl
	call Wait
	ex de,hl
	ld de,(Time_Saved)
	ld (hl),e
	inc hl
	ld (hl),d
	push hl
	ld hl,Congratu_Window
	ld de,$0204
	call Disp_Window
	ld hl,HiScore_Text
	call Disp_Text
	pop hl
	ld de,0018
	sbc hl,de
	ld (hl),0
	ld (Counter_Saved),hl
	ld b,16               ;max 16 letters
Get_Name:
	push hl
	push bc
	ld de,$302D
	ld (_penCol),de
	call _vputs
	ld a,124
	call _vputmap
	ld b,3
	ld hl,Nothing
	call _vputsn
Get_Name_Loop:
	call _getky
	or a
	jr z,Get_Name_Loop
	cp K_ENTER
	jr nz,Get_Name_Continue
	pop bc
	ld b,1
	push bc
	jr Del_Letter_Back
Get_Name_Continue:
	cp K_DEL
	jr nz,Not_Del_Letter
Del_Letter:
	pop bc
	ld hl,(Counter_Saved)
	ld a,b
	cp 16
	jr z,Get_Name_Back
	inc b
	dec hl
Get_Name_Back:
	inc b
	push bc
	jr Del_Letter_Back
Not_Del_Letter:
	sub K_PLUS
	jr c,Get_Name_Loop
	cp K_GRAPH-K_PLUS
	jr nc,Get_Name_Loop
	ld hl,Key_Translator
	ld d,0
	ld e,a
	add hl,de
	ld c,(hl)
	ld a,c
	or a
	jr z,Get_Name_Loop
	ld hl,(Counter_Saved)
	dec hl
	ld a,(hl)
	inc hl
	cp ' '
	jr nz,Not_Caps
	res 5,c
Not_Caps:
	ld (hl),c
	inc hl
Del_Letter_Back:
	ld (Counter_Saved),hl
	ld (hl),0
	pop bc
	pop hl
	djnz Get_Name
	jp MainMenu


Test_Box:					;
	call In_TileMap			; Est-ce que je suis Dans la TileMap.
	ret c					; Si carry = 1,non donc pas de test.
	call Get_The_Tile		; Quel est le Tile?
	or a					; Efface les flags (c,z,nc,nz...).
	bit 7,a					; Si bit 7 = 0 la boite est deja ouverte.
	ret z					; Donc pas de test.
	bit 6,a					; Est-ce c'est une boite ferm ou un drapeau.
	ret nz					; Si c'est un drapeau il ne faut pas l'ouvrir.
	res 7,a					; J'ouvre la boite.
	res 5,a					; J'ouvre aussi les ? .
	cp $09					; Est-ce que c'est une bombe?
	jr nz,Test_Around		; Non alors je continue les tests.
	scf						; Si s'en est une, Carry = 1 et fin du jeu.
	ret						; (Cela n'arrive qu'a la 1er ouverture).
Test_Around:				;
	push hl
	ld hl,Empty_Box
	dec (hl)
	pop hl
	call Change_The_Tile	; Je Change le Tile dans la TileMap.
	or a					; Est-ce que c'tait une boite vide?
	ret nz					; Si il y a quelque chose je stop ds cette direc
	dec l					; Je vais sur la boite au dessus. 
	call Test_Box			; Je test.
	inc h					; Je vais sur la boite au dessus a droite.
	call Test_Box			; Je test.
	inc l					; Je vais sur la boite a droite.
	call Test_Box			; Je test.
	inc l					; Je vais sur la boite au dessous a droite.
	call Test_Box			; Je test.
	dec h					; Je vais sur la boite au dessous.
	call Test_Box			; Je test.
	dec h					; Je vais sur la boite au dessous a gauche.
	call Test_Box			; Je test.
	dec l					; Je vais sur la boite a gauche.
	call Test_Box			; Je test.
	dec l					; Je vais sur la boite au dessus a gauche.
	call Test_Box			; Je test.
	inc	h					; Je vais sur la boite au dessus.
	inc l					; Je retourne sur la boite de ce dpart.
	or a					; Efface les Flags.
	ret						;

;__________________________________________________________________________;
;_______________________________ROUTINES___________________________________;
;__________________________________________________________________________;

Inc_Box_Number:				;
	call In_TileMap			; Est-ce que je suis Dans la TileMap.
	ret c					; Si carry = 1,non donc pas de test.
	call Get_The_Tile		; Quel est le Tile?
	cp $09					; Est-ce que c'est une bombe.
	ret nc					; Oui, alors je nens vais.
	inc a					; Non, alors j'augmente sa valeur.
	call Change_The_Tile	; Je la restitue dans la TileMap.
	ret						;

In_TileMap:					;
	ld a,$07				; a = 7 = cursor tout a droite.
	cp l					; Est-ce que je suis hors de la TileMap.
	ret c					; Si Carry=1 je suis hors TileMap donc je part.
	ld a,$0F				; a = 15 = cursor tout en bas.
	cp h					; Est-ce que je suis hors de la TileMap.
	ret c					; Si Carry=1 je suis hors TileMap donc je part.
	or a					; Carry flag = 0.
	ret						;

Draw_TileMap:				;
	push hl					; Save la position du cursor.
	ld hl,$0000				; Cursor position a (0,0).
	ld b,$80				; b = 128 boites Pour le loop.
Draw_TileMap_Loop:			;
	call Draw_HL_Tile		; Dessine le tile qui est montr par le cursor.
	call Move_HL_Cursor		; Dplace le cursor.
	djnz Draw_TileMap_Loop	; Et recommence  dessiner.
	pop hl					; restore la position du cursor.
	ret						;

Draw_HL_Tile:				;
	call Get_The_Tile		; Get the tile in the map
Draw_A_Tile:				; 
	bit 7,a					; Est-ce que la boite est ouverte?
	jr z,Draw_It			; Si oui,on la dessine(pour effacer le cursor) .
	bit 6,a					; Est-ce que c'est une boite?
	jr nz,Draw_Flag			; Si oui, je saute redessiner une boite.
	bit 5,a
	jr z,Draw_Box
	ld a,$0F
	jr Draw_It
Draw_Flag:
	ld a,$0A				; Rien de tout a? Alors c'est un drapeau($0A).
	jr Draw_It				; Je saute dessiner un drapeau .
Draw_Box:					;
	ld a,$0B				; a = $0B = code pour une boite.
Draw_It:					;
	and $1F					; Pour enlever les flags en bit 7 et 6.
	call PutSprite			; J'ai donc le bon code Sprite et je le dessine.
	ret						;

TileMap_Loc:				;
	ld a,l					; a = l = Y.
	rlca					; Y*2.
	rlca					; Y*4.
	rlca					; Y*8.
	rlca					; Y*16.
	add a,h					; y*16+X.
	ld e,a					;\e = Y*16+X.
	ld d,$00				;/d = 0 => de = Y*16+X.
	ld hl,TileMap			; TileMap start.
	add hl,de				; hl point to the good mem.
	ret						;

Get_The_Tile:				;
	push hl					; Save la position du cursor.
	call TileMap_Loc		; quel est la mem montr par le cursor
	ld a,(hl)				; je rcupre le Tile de cette mem.
	pop hl					; restore la position du cursor.
	ret						;

Change_The_Tile:			;
	push hl					; Save la position du cursor.
	push af					; Save le Tile que je veux mettre a la place.
	call TileMap_Loc		; quel est la mem montr par le cursor
	pop af					; Restore le Tile que je veux mettre a la place.
	ld (hl),a				; je met ce Tile dans la mem.
	pop hl					; restore la position du cursor.
	ret						;

Move_HL_Cursor:				;
	ld a,h					; a = X
	inc a					; X=X+1 dplace le cursor a droite.
	cp $10					; Est-ce qu'il est tout a droite.
	jr c,Move_HL_Cursor_Save; Non, alors je saute le sauver.
	inc l					; Y=Y+1 dplace le cursor en bas.
	xor a					; Recommence a droite.
Move_HL_Cursor_Save:		;
	ld h,a					; Sauvegarde la nouvelle position X.
	ret						;

;--------------------------------Return------------------------------------;

Exit:
	res 2, (iy+$23)
	ld a, $3C
	out (0), a
	ld hl,Name-1				;hl->name of program
	rst 20h						;copy to OP1
	rst 10h						;_findsym
	xor a
	ld hl,HiScore_Data-_asm_exec_ram+4	;offset
	add hl,de					;hl=pointer to data in original prog
	adc a,b						;in case we overlapped pages
	call _SET_ABS_DEST_ADDR
	xor a						;no absolute addressing now
	ld hl,HiScore_Data			;get data from here
	call _SET_ABS_SRC_ADDR
	ld hl,110					;number of bytes to save
	call _SET_MM_NUM_BYTES
	jp _mm_ldir					;copy data and return
	call ClearPage
	call _clrScrn
	call _homeup
	ret

;--------------------------Clear the Pages---------------------------------;

ClearPage:
	ld hl,$FC00
	call Clear1024
	ld hl,$F300
	call Clear1024
	ret
Clear1024:
	ld d,h
	ld e,l
	inc de
	ld (hl),0
	ld bc,1024
	ldir
	ret

;------------------------------Disp a Window-------------------------------;

Disp_Window:
	ld b,(hl)
	inc hl
	ld a,(hl)
	ld (Only_Title_Window),a
	ld c,0
	inc hl
Put_Window_Loop1:
	push bc
	push de
Put_Window_Loop2:
	ld a,(hl)
	ex de,hl
	push de
	call PutSprite
	pop de
	ex de,hl
	inc d
	inc hl
	djnz Put_Window_Loop2
	pop de
	pop bc
	inc e
	inc c
	ld a,c
	cp 2
	jr nz,Big_Window
	dec e
Big_Window:
Only_Title_Window = $+1 
	cp $FF
	jr nz,Put_Window_Loop1
	ret

;----------------------------------Wait------------------------------------;

Wait:
	ld hl,$0000				; Curseur Position (0,0) = en haut a gauche
	xor a
	ld (UserCounter),a
	ld (Time),hl
	inc a
Wait_Before_text:
	ld hl,(Time)
	cp l
	jr nz,Wait_Before_text
	ret

;--------------------------------Contraste---------------------------------;

inc_contrast:
	push af
	ld a,($C008)
	cp 30
	jr z,end_contrast
	inc a
	ld ($C008),a
	out (2),a
	jr end_contrast
dec_contrast:
	push af
	ld a,($C008)
	or a
	jr z,end_contrast
	dec a
	ld ($C008),a
	out (2),a
end_contrast:
	pop af
	ret


Draw_Line_H:
	ld a,(hl)
	or d
	ld (hl),a
	inc hl
	ld c,$FF
	ld b,12
Draw_Line_H_Loop:
	ld (hl),c
	inc hl
	djnz Draw_Line_H_Loop
	ld a,(hl)
	or e
	ld (hl),a
	inc hl
	inc hl
	inc hl
	ret

;-------------------------------Draw line----------------------------------;

Draw_Line_V:
	push hl
	push bc
	push de
	ld (hl),d
	ld de,16
Draw_Line_V_Loop:
	add hl,de
	ld a,(hl)
	or c
	ld (hl),a
	djnz Draw_Line_V_Loop
	add hl,de
	pop de
	pop bc
	ld c,d
	ld a,(hl)
	or c
	ld (hl),a
	pop hl
	ld de,$0900
	add hl,de
	ld de,16
Draw_Line_V_Loop2:
	add hl,de
	ld a,(hl)
	or c
	ld (hl),a
	djnz Draw_Line_V_Loop2
	ret

;-------------------------------Disp text----------------------------------;

Disp_Text:
	ld d,(hl)
	ld a,255
	cp d
	ret z
	inc hl
	ld e,(hl)
	inc hl
	ld (_penCol),de
	call _vputs
	jr Disp_Text

;-----------------------------Disp HL as nb--------------------------------;

Show_a_NB:
	ld (_penCol),de			;and put it in
    ld de,StringPlace+2		;start of unpacking         [4]
    ld b,3					;2 digits                   [5]
Show_a_NB2:
    call _divHLby10			;divide hl by 10 and a contains remainder
    add a,'0'				;asciiize it
    ld (de),a				;put it in
    dec de					;next digit place to load
    djnz Show_a_NB2			;keep going
    ld hl,StringPlace		;now we put it back
	ld b,3
    call _vputsn				;and display the score
	ret

;__________________________________________________________________________;
;________________________________OTHER_____________________________________;
;__________________________________________________________________________;

#include "Demineur_Pause.asm"

#include "Demineur_GrayScale.asm"

#include "Demineur_PutSprite.asm"

#include "Demineur_Textes.asm"

#include "Demineur_Sprites.asm"

.end
