;__________________________________________________________________________;
;_______________________________PUTSPRITE__________________________________;
;__________________________________________________________________________;

PutSprite:				;
	push af				; Save the Sprite number.
	push bc				; Save bc.
	push hl				; Save (X,Y) h=x et l=y.
	push ix				; Save IX.
	push hl				; Save (X,Y) h=x et l=y.
	ld hl,$00			; hl=$00.
	ld l,a				; a = Sprite number, +125 if box is not opened.
	res 7,l				; l = Sprite number opened.
	add hl,hl			; hl*2.
	add hl,hl			; hl*4.
	add hl,hl			; hl*8 = mem_loc of the sprite, starting at Sprites.
	ld e,l
	ld d,h
	add hl,hl
	add hl,de
	ld de,Sprites		; de = Sprites start.
	add hl,de			; Now hl point to the good Sprite.
	push hl				; \Push Sprite pointer in order to
	pop ix				; /load it in IX.
	pop hl				; Restore (X,Y).
	ld d,l				;\d = Y.
	ld e,$00			;/e = 0 => de = Y*16.
	ld l,h				;\l = X.
	ld h,e				;/h = 0 => hl = X.
	srl d				;\d/2 cf = bit 0.
	rr e				;/bit 7 = cf => de = de/2 = Y*8.
	add hl,de			; hl = Y*8+X.
	push hl
	ld de,$FC00			; Display RAM.
	add hl,de			; hl = Where to draw the Sprite.
	ld de,$0010			; de = 16 in order to draw a line down.
	ld b,$08			; b = 08 because it is the height ot Sprites.
Dark_Layer:
	ld c,(ix+$00)		; Load a byte of the sprite.
	ld a,(ix+$10)
	cpl
	and (hl)
	or c
	ld (hl),a
	add hl,de			; Move a line down.
	inc ix				; Get the next byte of the Sprite.
	djnz Dark_Layer		; Do tha 8 times.
	ccf
	pop hl
	ld de,$F300
	add hl,de
	ld de,$0010
	ld b,$08
Light_Layer:
	ld c,(ix+$00)		; Load a byte of the sprite.
	ld a,(ix+$08)
	cpl
	and (hl)
	or c
	ld (hl),a
	add hl,de			; Move a line down.
	inc ix				; Get the next byte of the Sprite.
	djnz Light_Layer		; Do tha 8 times.
	pop ix				; Restore IX
	pop hl				; Restore (X,Y) h=x et l=y.
	pop bc				; Restore bc
	pop af				; Restore the Sprite number
	ret
